#!usr/bin/python3
import json
import time
import paho.mqtt.client as mqtt
from sympy import false
import os
import ssl

path = os.path.abspath(os.path.dirname(os.path.dirname(__file__)))
resourcesPath = path + os.sep 

tls = {
    "ca_certs": resourcesPath+"file\\ca.crt",
    "certfile": "./file/client.crt",
    "keyfile": "./file/client.key",
    "tls_version": ssl.PROTOCOL_TLSv1_2
}

class myMqtt:
    def __init__(self,  mqtt_info):
        self._topic_enable = False
        self._topic = []

        self._mqtt_enable = False
        self._mqtt_info = mqtt_info
        self._client = None
        self._context = None

        self._start_flag = False
        self._request_flag = False

    def open_mqtt(self):
        # open mqtt
        try:
            if 'user' in self._mqtt_info and 'password' in self._mqtt_info \
                    and 'broker' in self._mqtt_info and 'port' in self._mqtt_info:
                self._client = mqtt.Client()
                self._client.username_pw_set(self._mqtt_info['user'], self._mqtt_info['password'])        
                self._client.on_connect = self.on_connect
                self._client.on_message = self.on_message
                # self._client.tls_set(tls)
                # self._client.tls_set(ca_certs=resourcesPath +"file\\cacert.pem", certfile=resourcesPath + "file\\cert.pem",
                #                       keyfile=resourcesPath + "file\\key.pem",tls_version=ssl.PROTOCOL_TLSv1_2)
                # self._client.tls_insecure_set(True)
                self._client.connect(self._mqtt_info['broker'], self._mqtt_info['port'])
                self._mqtt_enable = True
                print("mqtt config success")
            else:
                self._mqtt_enable = False
                print("mqtt config error")
        except Exception as exp:
            self._mqtt_enable = False
            print(exp)

    def set_add_topic(self, topic):
        self._topic_enable = True
        self._topic.append(topic)

    def get_add_topic(self):
        if self._topic_enable:
            return self._topic
        else:
            return None

    def clear_topic(self):
        self._topic = []
        self._topic_enable = False

    def on_connect(self, client, userdata, flags, rc):
        if self._topic_enable and self._mqtt_enable:
            for index in self._topic:
                self._client.subscribe(index)
                print(index)
            self._start_flag = True

    def on_message(self, client, userdata, msg):
        try:
            if self._topic_enable and self._mqtt_enable:
                if 'Request' in msg.topic:
                    self._request_flag = True
 
        except Exception as exp:
            print(exp)

    def publish(self, config_topic, data):
        try:
            if self._topic_enable and self._mqtt_enable:
                self._client.publish(config_topic,  json.dumps(data, separators=(',', ':')), qos=1)
        except Exception as exp:
            print(exp)

    def loop_task(self):
        try:
            if self._topic_enable and self._mqtt_enable:
                self._client.loop_forever()
        except Exception as exp:
            print(exp)

