import pandas as pd
import matplotlib.pyplot as plt
from io import StringIO


file_path = 'data.csv'
# Read data into a pandas DataFrame
df = pd.read_csv(file_path, sep=" ", parse_dates=["Time"])

# Convert Time to seconds for plotting
df['Time_in_seconds'] = df['Time'].dt.hour * 3600 + df['Time'].dt.minute * 60 + df['Time'].dt.second

# Plotting
plt.figure(figsize=(100, 30))
plt.plot(df['Time_in_seconds'], df['dB'], marker='o')
plt.title('dB Level Over Time')
plt.xlabel('Time (seconds)')
plt.ylabel('dB Level')
plt.grid(True)
plt.savefig('result_noise_data.png') 
